/*
 * ICMultilensRecommender.java
 *
 * Created on 6 de Fevereiro de 2007, 08:59
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.unicamp.ic.recommender.multilens;

import br.unicamp.ic.recommender.engine.BasicEngine;
import br.unicamp.ic.recommender.config.DBConfig;
import br.unicamp.ic.recommender.dao.RatingDAO;
import br.unicamp.ic.recommender.dao.ItemDAO;
import br.unicamp.ic.recommender.entity.Item;
import java.sql.Connection;
import java.sql.PreparedStatement;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import org.grouplens.multilens.CosineModel;
import org.grouplens.multilens.CosineRecModel;
import org.grouplens.multilens.CosineRec;
import org.grouplens.multilens.ZScore;
import org.grouplens.multilens.Recommendation;


/**
 *
 * @author daniel
 */
public class ICMultilensRecommender extends BasicEngine{
    
    /** Creates a new instance of ICMultilensRecommender */
    public ICMultilensRecommender() {
    }
    
    private void checkConnection ()  {
        try {
             if (this.connection.isClosed()) {
                this.getConnection();
             }
        } catch (Exception e) {
             e.printStackTrace();
         }
    }
     
     private int cleanCollaborativeModel () {
        try {
            String deleteSQL = "DELETE FROM " + this.getConfigParameter(this.getClass().getName(),"collaborativemodel");            
            PreparedStatement deleteSt = this.connection.prepareStatement(deleteSQL);
            return deleteSt.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
            return 0;
        }
    }
    
    
     public void makeModel () {
        RatingDAO ratingDAO = new RatingDAO(this.dbName);
        this.cleanCollaborativeModel();
                        
        CosineModel aModel = new CosineModel (Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"SIZE_ROW_COSINE_COLLABORATIVE_MODEL")),Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"SIZE_COL_COSINE_COLLABORATIVE_MODEL")));
        ZScore myFilt = new ZScore();
        aModel.build(true,this.getConfigParameter(this.getClass().getName(),"RATINGS_TABLE"),myFilt);
        aModel.buildFinal();
        
        aModel.setModelTable(this.getConfigParameter(this.getClass().getName(),"COLLABORATIVE_MODEL_TABLE"));
        aModel.writeModel();
    }
    
     public List getRecommendationsByUser (br.unicamp.ic.recommender.entity.User user)  {    
         
         this.checkConnection();
        CosineModel aModel = new CosineModel (Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"SIZE_ROW_COSINE_COLLABORATIVE_MODEL")),Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"SIZE_COL_COSINE_COLLABORATIVE_MODEL")));
        aModel.setModelTable (this.getConfigParameter(this.getClass().getName(),"COLLABORATIVE_MODEL_TABLE"));
        aModel.readModel(Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"MAX_MOST_SIMILAR_COLLABORATIVE_MODEL_BY_USER")),true);
        CosineRec myRE = new CosineRec (aModel);
        
        org.grouplens.multilens.User recUser = new org.grouplens.multilens.User (new Integer(user.getUserId()).toString());
        TreeSet myRecs = myRE.getRecs (recUser, 10, false, null);

        Iterator it = myRecs.iterator();
        List recList = new ArrayList();
        ItemDAO itemDAO = new ItemDAO(this.dbName); 
        int i=0;
        while (it.hasNext()&&(i<Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"MAX_SIZE_COLLABORATIVE_LIST")))) {
                Recommendation currentRec = (Recommendation) it.next();    
                Item currentItem = (Item) itemDAO.selectByKey(new Integer(currentRec.getItemID()));
                recList.add(currentItem);
                i++;
        }
        return recList;
     }
     
     /*
      *    public int cleanCollaborativeModel () {
        try {
            PreparedStatement insert = connection.prepareStatement("DELETE FROM collaborativemodel");
            return insert.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
            return 0;
        }
    }
      */

     
     public List getRecommendationsByItem (br.unicamp.ic.recommender.entity.Item item)  {           
        this.checkConnection();
        CosineModel aModel = new CosineModel (Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"SIZE_ROW_COSINE_COLLABORATIVE_MODEL")),Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"SIZE_COL_COSINE_COLLABORATIVE_MODEL")));
        aModel.setModelTable(this.getConfigParameter(this.getClass().getName(),"COLLABORATIVE_MODEL_TABLE"));
        aModel.readModel(Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"MAX_MOST_SIMILAR_COLLABORATIVE_MODEL_BY_ITEM")),false);
        CosineRec myRE = new CosineRec (aModel);
       
        Set setItems = new TreeSet();
        setItems.add(new Integer(item.getItemId()));
        TreeSet myRecs = myRE.getRecs(setItems,10,false,null);
                                        
        Iterator it = myRecs.iterator();
        List recList = new ArrayList();
        ItemDAO itemDAO = new ItemDAO(this.dbName); 
        int i=0;
        while (it.hasNext()&&(i<Integer.parseInt(this.getConfigParameter(this.getClass().getName(),"MAX_SIZE_COLLABORATIVE_LIST")))) {
                Recommendation currentRec = (Recommendation) it.next();    
                Item currentItem = (Item) itemDAO.selectByKey(new Integer(currentRec.getItemID()));
                recList.add(currentItem);
                i++;
        }
        return recList;
     }
}
